<?php

/**
 * Implements hook_views_data().
 */
function skilling_views_data_alter(&$data) {
  $data['views']['table']['group'] = t('Custom Global');
  $data['views']['table']['join'] = [
    // #global is a special flag which allows a table to appear all the time.
    '#global' => [],
  ];

  $data['views']['date_plus_days_field'] = [
    'title' => t('Date plus days field'),
    'help' => t('Creates a field showing the date you get by adding a number of days to a date.'),
    'group' => 'Skilling',
    'field' => [
      'id' => 'date_plus_days_field',
    ],
  ];

  // Show whether a notice has been read.
  $data['views']['is_notice_unread'] = [
    'title' => t('Is notice unread?'),
    'help' => t('Creates a field showing whether a notice has been read.'),
    'group' => 'Skilling',
    'field' => [
      'id' => 'is_notice_unread',
    ],
  ];

  $data['views']['history_details_display_field'] = [
    'title' => t('History details field'),
    'help' => t('Creates a field for Views showing the details of a history event.'),
    'group' => 'Skilling',
    'field' => [
      'id' => 'history_details_display_field',
    ],
  ];

  $data['views']['history_details_xml_field'] = [
    'title' => t('History details XML field'),
    'help' => t('Creates a field for Views with the details of a history event in XML.'),
    'group' => 'Skilling',
    'field' => [
      'id' => 'history_details_xml_field',
    ],
  ];

  $data['node__field_event_type_name']['history_event_type_filter'] = array(
    'filter' => [
      'title' => t('History event type filter'),
      'help' => t('Specify the history event types.'),
      'field' => 'field_event_type_name',
      'id' => 'history_event_type_filter',
      'allow empty' => TRUE,
      'group' => 'Skilling',
    ],
  );

  $data['node__field_when_read']['unread_filter'] = array(
//  $data['node_field_data']['unread_filter'] = array(
    'filter' => [
      'title' => t('Notices to show'),
      'help' => t('Only show unread notices, or show all?.'),
      'field' => 'field_when_read_value',
      'id' => 'unread_filter',
      'group' => 'Skilling',
    ],
  );



  // For query plugin giving data on one student's exercise submissions.
  $data['student_submissions']['table']['group'] = t("Student's submissions");
  $data['student_submissions']['table']['base'] = [
    'title' => t("Student's submissions"),
    'help' => t("A student's exercise submissions."),
    'query_id' => 'student_submissions',
  ];
  // Fields.
  $data['student_submissions']['exercise_nid'] = [
    'title' => t('Exercise id'),
    'help' => t('Node id of an exercise.'),
    'field' => [
      'id' => 'numeric',
    ],
  ];
  $data['student_submissions']['exercise_title'] = [
    'title' => t('Exercise title'),
    'help' => t('Title of an exercise.'),
    'field' => [
      'id' => 'standard',
    ],
  ];
  $data['student_submissions']['exercise_internal_name'] = [
    'title' => t('Exercise internal name'),
    'help' => t('Internal name of an exercise.'),
    'field' => [
      'id' => 'standard',
    ],
  ];
  $data['student_submissions']['where_referenced'] = [
    'title' => t('Where referenced'),
    'help' => t('Lessons that include the exercise.'),
    'field' => [
      'id' => 'markup',
      'format' => 'full_html',
    ],
  ];
  $data['student_submissions']['completed'] = [
    'title' => t('Completed?'),
    'help' => t('Has the student completed the exercise?'),
    'field' => [
      'id' => 'boolean',
    ],
    'filter' => [
      'id' => 'completed_exercise',
    ],
  ];
  $data['student_submissions']['status'] = [
    'title' => t('Status'),
    'help' => t('The status of submissions for an exercise.'),
    'field' => [
      'id' => 'standard',
    ],
    'filter' => [
      'id' => 'filter_status',
    ],
  ];
  $data['student_submissions']['when_first_submission'] = [
    'title' => t('First submission date/time'),
    'help' => t('When was the first submission for an exercise?'),
    'field' => [
      'id' => 'date',
    ],
  ];
  $data['student_submissions']['submissions'] = [
    'title' => t('Submissions'),
    'help' => t("Submissions for a student's exercises."),
    'field' => [
      'id' => 'markup',
      'format' => 'full_html',
    ],
  ];

}
