<?php

namespace Drupal\skilling\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines a Skilling history item annotation object.
 *
 * @see \Drupal\skilling\Plugin\HistoryItemManager
 * @see plugin_api
 *
 * @Annotation
 */
class SkillingHistoryItem extends Plugin {


  /**
   * The plugin ID.
   *
   * @var string
   */
  public $id;

  /**
   * The name of the event type.
   *
   * @var string
   */
  public $event_type_name;

  /**
   * The pretty label of the plugin.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $label;

  /**
   * A brief, human readable, description of the event type.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $description;

}
