<?php

namespace Drupal\skilling\Plugin\HistoryItem;

use Drupal\skilling\Plugin\HistoryItemBase;

/**
 * Provides a message-from-student-to-instructor history event.
 *
 * @SkillingHistoryItem(
 *  id = "skilling_message_student_to_instructor_history_event",
 *  event_type_name = "student_sent_message_to_instructor",
 *  label = @Translation("Message from student to instructor"),
 *  description = @Translation("A student sent a message to an instructor."),
 * )
 */
class MessageStudentToInstructor extends HistoryItemBase {

  /**
   * {@inheritdoc}
   *
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\skilling\Exception\SkillingException
   */
  public function getDetailsRenderable() {
    $messageFromSomeoneToSomeone = new MessageFromSomeoneToSomeone();
    $result = $messageFromSomeoneToSomeone->getDetailsRenderable(
      $this->historyEventNode,
      'history_message_student_to_instructor_deets'
    );
    return $result;
//    list($instructorId, $studentId, $subject, $message) = $this->extractDeets();
//    $result = [
//      '#theme' => 'history_message_instructor_to_student_deets',
//      '#subject' => $subject,
//      '#message' => $message,
//    ];
//    /** @var \Drupal\skilling\SkillingCurrentUser $currentUser */
//    $currentUser = \Drupal::service('skilling.skilling_current_user');
//    if ($currentUser->isAdministrator()) {
//      // Admins get more stuff in their deets.
//      /** @var \Drupal\skilling\SkillingUserFactory $userFactory */
//      $userFactory = \Drupal::service('skilling.skilling_user_factory');
//      $student = $userFactory->makeSkillingUser($studentId);
//      $instructor = $userFactory->makeSkillingUser($instructorId);
//      $result['#instructor_id'] = $instructorId;
//      $result['#student_id'] = $studentId;
//      $result['#student_name'] = $student->getAccountName();
//      $result['#instructor_name'] = $instructor->getAccountName();
//    }
//    return $result;
  }

  /**
   * {@inheritdoc}
   */
  public function getDetailsXml() {
    $messageFromSomeoneToSomeone = new MessageFromSomeoneToSomeone();
    $result = $messageFromSomeoneToSomeone->getDetailsXml(
      $this->historyEventNode,
      'message-student-to-instructor'
    );
    return $result;
//    list($instructorId, $studentId, $subject, $message) = $this->extractDeets();
//    $result =
//       '<message-instructor-to-student student-id="' . $studentId . '" instructor-id="' . $instructorId . '">'
//        . "<subject>$subject</subject>"
//        . "<message>$message</message>"
//      . '</message-instructor-to-student>';
//    return $result;
  }

  /**
   * Extract the details into separate variables.
   *
   * @return array
   *   Deets in variables.
   */
//  protected function extractDeets() {
//    $deets = $this->historyEventNode->get('field_details')->value;
//    // Unserialize it.
//    $deets = unserialize($deets);
//    $instructorId = $deets['instructor_id'];
//    $studentId = $deets['student_id'];
//    $subject = $deets['subject'];
//    $message = $deets['message'];
//    return [$instructorId, $studentId, $subject, $message];
//  }

  /**
   * Is the event to be logged in history?
   *
   * Always log.
   *
   * @return bool
   *   Whether to log the event.
   */
  public function isLogged() {
    return TRUE;
  }

}
