<?php

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-02-16 at 20:05:00.
 */
class ArithmeticTest extends PHPUnit_Framework_TestCase {

	/**
	 * @var Expression
	 */
	protected $object;

	/**
	 * Sets up the fixture, for example, opens a network connection.
	 * This method is called before a test is executed.
	 */
	protected function setUp() {		
		$this->object = new Expression();
	}

	public function testAdditon() {
		$this->assertEquals($this->object->evaluate('2+3'), 5);
		$this->assertEquals($this->object->evaluate('2+3+4'), 9);
		$this->assertEquals($this->object->evaluate('0+0'), 0);
		$this->assertEquals($this->object->evaluate('1+-1'), 0);
	}

	public function testSubtraction() {
		$this->assertEquals($this->object->evaluate('3-2'), 1);
		$this->assertEquals($this->object->evaluate('2-3'), -1);
		$this->assertEquals($this->object->evaluate('2-3-4'), -5);
		$this->assertEquals($this->object->evaluate('0-0'), 0);
		$this->assertEquals($this->object->evaluate('1-(-1)'), 2);
	}

	public function testMultiplication() {
		$this->assertEquals($this->object->evaluate('2*3'), 6);
		$this->assertEquals($this->object->evaluate('2*3*4'), 24);
		$this->assertEquals($this->object->evaluate('0*0'), 0);
		$this->assertEquals($this->object->evaluate('1*-1'), -1);
	}

	public function testDivision() {
		$this->assertEquals($this->object->evaluate('6/3'), 2);
		$this->assertEquals($this->object->evaluate('24/4/3'), 2);
		$this->assertEquals($this->object->evaluate('0/1'), 0);
	}

	public function testDivisionByZero() {
		$this->setExpectedException('PHPUnit_Framework_Error_Warning', 'Division by zero');		
		$this->object->evaluate('0/0');
	}

	public function testModulo() {
		$this->assertEquals($this->object->evaluate('12%1'), 0);
		$this->assertEquals($this->object->evaluate('12%2'), 0);
		$this->assertEquals($this->object->evaluate('12%3'), 0);
		$this->assertEquals($this->object->evaluate('12%4'), 0);
		$this->assertEquals($this->object->evaluate('12%5'), 2);
		$this->assertEquals($this->object->evaluate('12%6'), 0);
		$this->assertEquals($this->object->evaluate('12%7'), 5);
		$this->assertEquals($this->object->evaluate('12%8'), 4);
	}

	/**
	 * @expectedException PHPUnit_Framework_Error_Warning
	 * @expectedExceptionMessage Division by zero
	 */
	public function testModuleByZero() {
		$this->setExpectedException('PHPUnit_Framework_Error_Warning', 'Division by zero');		
		$this->object->evaluate('12%0');
	}
}
